!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! -*- Mode: F90 -*- !!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!! CommMonde.f90 --- Les constructeurs de groupes de processus
!! 
!! Auteur          : Jalel Chergui (CNRS/IDRIS - France) <Jalel.Chergui@idris.fr>
!! Cr le         : Tue Apr  2 16:35:25 1996
!! Dern. mod. par  : Jalel Chergui (CNRS/IDRIS - France) <Jalel.Chergui@idris.fr>
!! Dern. mod. le   : Thu Mar 13 17:29:34 1997
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

program CommMonde 
include 'mpif.h'
integer, parameter  :: m=16
integer             :: nb_procs,rang,code
real, dimension(m)  :: a

call MPI_INIT(code)
call MPI_COMM_SIZE(MPI_COMM_WORLD, nb_procs, code)
call MPI_COMM_RANK(MPI_COMM_WORLD, rang, code)

if ( rang == 0 ) then
    print *, 'Nombre de processeurs ', nb_procs
endif

!*** Initialisation du vecteur A
a(:) = 0.
if ( rang == 2 ) a(:)= 2.

!*** Diffuser le message a tous les processus
call MPI_BCAST(a,m,MPI_REAL,2,MPI_COMM_WORLD,code)

print*,'rang : ',rang,' a(:) = ',a(:)
  
call MPI_FINALIZE(code)
end program CommMonde
