/*******************************************************************************
*  CommSplit.c --- Le constructeur MPI_Comm_split()
*
* Auteur          : Jalel Chergui (CNRS/IDRIS - France) <Jalel.Chergui@idris.fr>
* Cr le         : Tue Apr  2 16:29:22 1996                                    
* Dern. mod. par  : Jalel Chergui (CNRS/IDRIS - France) <Jalel.Chergui@idris.fr>
* Dern. mod. le   : Tue May 19 15:45:51 1998
*******************************************************************************/ 
#include "mpi.h"
#include <stdio.h>

#define M      16

int main(int argc,char *argv[])
{
  int          nb_procs, rang, clef, couleur, i ;
  float        a[M] ;
  MPI_Comm     comm ;

  MPI_Init(&argc,&argv);
  MPI_Comm_rank(MPI_COMM_WORLD,&rang) ;
  MPI_Comm_size(MPI_COMM_WORLD,&nb_procs) ;

/*** Initialisation du vecteur A */
  for (i=0; i<M ; i++)
  {
    if (rang == 2 || rang == 5)
      a[i] = (float) rang ;
    else
      a[i] = 0. ;
  }

if ( rang%2 == 0 )
{
/*** Couleurs et clef des processus pairs */
   couleur = 0 ;
   switch (rang)
   {
     case 2 :
       clef = 0 ;
       break ;
     case 0 :
       clef = 1 ;
       break ;
     default :
       clef = rang ;
   }
}
else
{
/*** Couleurs et clefs des processus impairs */
   couleur = 1 ;
   switch (rang)
   {
     case 5 :
       clef = 0 ;
       break ;
     default :
       clef = rang ;
   }
}

/*** Creer les communicateurs pair et impair */
MPI_Comm_split(MPI_COMM_WORLD,couleur,clef,&comm) ;

/*** Le processus 0 de chaque communicateur diffuse son 
 *** message aux processus de son groupe.               */
MPI_Bcast(a, M, MPI_FLOAT, 0, comm) ;

printf ("rang : %d ; a(:) = ", rang) ;
for (i=0 ; i < M; i++ )
   printf (" %f",a[i]);
printf ("\n");
  
/*** Destruction des communicateurs */
MPI_Comm_free(&comm) ;

MPI_Finalize() ;
}
