!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! -*- Mode: F90 -*- !!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!! allgather.f90 --- Exemple d'utilisation du sous-programme MPI_ALLGATHER
!! 
!! Auteur          : Denis GIROU (CNRS/IDRIS - France) <Denis.Girou@idris.fr>
!! Cr le         : Wed Apr  3 14:59:35 1996
!! Dern. mod. par  : Denis GIROU (CNRS/IDRIS - France) <Denis.Girou@idris.fr>
!! Dern. mod. le   : Wed Apr  3 15:02:22 1996
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

program allgather
  implicit none

  include 'mpif.h'
  integer, parameter              :: nb_valeurs=128
  integer                         :: nb_processus,rang,longueur_tranche,i,code
  real, dimension(nb_valeurs)     :: donnees
  real, allocatable, dimension(:) :: valeurs

  call MPI_INIT(code)

  call MPI_COMM_RANK(MPI_COMM_WORLD,rang,code)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,nb_processus,code)

  longueur_tranche=nb_valeurs/nb_processus
  allocate(valeurs(longueur_tranche))

!  valeurs(:)=(/(1000.+rang*longueur_tranche+i,i=1,longueur_tranche)/)
  do i=1,longueur_tranche
     valeurs(i)= 1000.+rang*longueur_tranche+i
  end do

  call MPI_ALLGATHER(valeurs,longueur_tranche,MPI_REAL, &
                     donnees,longueur_tranche,MPI_REAL,MPI_COMM_WORLD,code)

  print *,'Moi, processus ',rang,', j''ai recu ', &
          donnees(1),' ... ',donnees(longueur_tranche+1), &
          ' ... ',donnees(nb_valeurs)

  call MPI_FINALIZE(code)

end program allgather
